#include "..\script_component.hpp"

/*
 * Function: forge_server_admin_fnc_verifyAdminStore
 * Author: IDSolutions
 *
 * [Description]
 * Ensures the admin store is initialized and returns the store object.
 * Acts as a singleton accessor for the admin store interface.
 * If the store doesn't exist yet, it initializes it first.
 *
 * Arguments:
 * None
 *
 * Return Value:
 * Admin Store <OBJECT> - The admin store interface object
 *
 * Example:
 * private _adminStore = call forge_server_admin_fnc_verifyAdminStore
 *
 * Public: No
 */

private _store = GETMVAR(FORGE_ADMIN_STORE_REG,nil);

if (isNil "_store") then {
    _store = call FUNC(initAdminStore);

    diag_log text "[FORGE Admin] Admin store initialized";
};

_store