#include "..\script_component.hpp"

/*
 * Function: forge_server_db_fnc_loadGameState
 * Author: J. Schmidt
 * 
 * Description:
 * Loads game state from mission or profile namespace and sets appropriate variables
 *
 * Arguments:
 * 0: _nameSpace - Namespace to load from (mission, profile) <STRING> (default: mission)
 *
 * Return Value:
 * Success <BOOL>
 */

params [["_nameSpace", "mission", [""]]];

private _companyState = createHashMap;

if (_nameSpace == "mission") then {
    _companyState = ["companyStore", "CompanyState"] call FUNC(loadFromMission);
} else {
    _companyState = ["companyStore", "CompanyState"] call FUNC(loadFromProfile);
};

if (!isNil "_companyState") then {
    companyFunds = _companyState getOrDefault ["funds", 0];
    companyRating = _companyState getOrDefault ["rating", 0];
    companyShareholders = _companyState getOrDefault ["operations", []];
};

true